function WindowService(ScreenService,ConfigIpRepository) {
	var self = this;

	const WINDOWS = {
		// smart promo screens
		PROMO_SCREEN: "smartPromo",
		SUBPROMO_SCREEN: "subPromo",
		CHECK_PROMO_SCREEN: "checkPromo",

		// account screens
		PAYMENT_SCREEN: "accountPaymentNamed",
		ADVANCE_PAYMENT_SCREEN: "accountAdvancePaymentNamed",
		PAYMENT_TYPES_SCREEN: "paymentMenu",
		ADVANCE_PAYMENT_TYPES_SCREEN: "advancePaymentMenu",
		CLOSE_ACCOUNT_SCREEN: "closeAccount",
		SPLIT_PRODUCTS_SCREEN: "splitProducts",
		DELAYED_PRODUCTS_SCREEN: "delayedProducts",
		CANCEL_PRODUCT_SCREEN: "cancelProductComanda",
		CANCEL_PRODUCT_SCREEN2: "cancelProductMesa",
		TRANSFERS_SCREEN: "transfers",
		TRANSACTIONS_SCREEN: "transactions",
		ACCOUNT_DETAILS_SCREEN: "accountDetails",
		CHECK_ORDER_SCREEN: "checkOrderPos",
		CHECK_ORDER_SCREEN2: "checkOrderGrp",
		SEND_MESSAGE_SCREEN: "sendMessage",
		MENU_SCREEN: "menu",

		// tables screens
		TABLES_SCREEN: "tables",
		GROUP_TABLE_SCREEN: "groupTable",
		LOGIN_SCREEN: "login",
		LOGIN_FILIAL_SCREEN: "loginAuth",

		// bill screens
		BILLS_SCREEN: "bills",
		PARENT_DASHBOARD_SCREEN: "parentDashboard",
		ACCOUNT_DETAILS_SCREEN_BILL: "accountDetailsBill",
		BILL_LOGIN_SCREEN: "billLogin",

		// order screens
		ORDER_CHECK_ORDER_SCREEN: "orderCheckOrder",
		ORDER_TEMPORARY_SCREEN: "orderTemp",
		ORDER_LOGIN_SCREEN: "orderLogin",
		ORDER_ACCESS_SCREEN: "orderAccess",
		ORDER_MENU_SCREEN: "orderMenu",
		NEW_CONSUMER_SCREEN: "newConsumer",
        COMPRE_GANHE_SCREEN: "compreGanhe",

		// register screens
		OPEN_REGISTER_SCREEN: "openRegister",
		CLOSE_REGISTER_SCREEN: "closeRegister",

		// delivery screens
		DELIVERY_ORDERS_SCREEN: "delivery",
		DELIVERY_ORDER_DETAIL_SCREEN: "orderDelivery"
	};

	this.openWindow = function(newWindow) {
		return ScreenService.openWindow(WINDOWS[newWindow]);
	}.bind(this);

	this.log = function(texto,pasta,idEnvio){
		idEnvio=idEnvio||null;
		return new Promise(function (resolve, reject) {
			try{
				if(!pasta){ pasta="LogFrontEnd"; }
				ConfigIpRepository.findOne().then(function (ipInfo) {
					try{
						if(!ipInfo||!projectConfig){return;}
						if(!ipInfo.ipForBack||!projectConfig.serviceUrl){return;}
						stBackend = projectConfig.serviceUrl.split("/");
						stBackend.pop();
						stBackend = stBackend.join("/");
						stBackend = stBackend+"/..";
						if (ipInfo.ipForBack.includes("teknisa.cloud")) return;

						var arrUrl = ipInfo.ipForBack.split('/');
						//verifica se o nome odhen-pos ou odhenpos/main esta se repetindo
						var arrServiceUrl = stBackend.split('/');
						if(arrUrl[arrUrl.length-1].toLowerCase() == arrServiceUrl[2].toLowerCase() && arrUrl[arrUrl.length-2].toLowerCase() == arrServiceUrl[1].toLowerCase()){
							arrServiceUrl.splice(1,2);
						} else if(arrUrl[arrUrl.length-1].toLowerCase() == arrServiceUrl[1].toLowerCase()){
							arrServiceUrl.splice(1,1);
						}
						stBackend = arrServiceUrl.join('/');
						if(!idEnvio){
							var dataAtual = new Date();
							idEnvio = dataAtual.getDate()+"-"+(dataAtual.getMonth()+1)+"-"+dataAtual.getFullYear()+" "+dataAtual.getHours()+":"+dataAtual.getMinutes()+":"+dataAtual.getSeconds()+"."+dataAtual.getMilliseconds();
						}
						$.post(
							ipInfo.ipForBack+"/"+stBackend+"/src/Util/Log.php?CDFILIAL="+(window.CDFILIAL||'')+"&CDCAIXA="+(window.CDCAIXA||'')+"&PASTA="+pasta,
							{ "TEXTO":texto||'' },
							function(){
								self.filaLog=self.filaLog||{};
								if(self.filaLog[idEnvio]){
									self.filaLog[idEnvio] = null;
									delete self.filaLog[idEnvio];
								}
								setTimeout(function(){
									self.processaFilaLog(true);
								},(!idEnvio)?0:1000);
							}
						).fail(function(){
							self.filaLog=self.filaLog||{};
							if(!self.filaLog[idEnvio]){
								self.filaLog[idEnvio] = {"texto":(texto||'')};
							}
							self.processaFilaLog();
						});
					}catch(e){ }
				});
			}catch(e){ }
			resolve();
		});
	};

	window.log = self.log;

	this.processaFilaLog=function(todos){
		if(!self.processandoFila){
			self.processandoFila = true;
			setTimeout(function(){
				self.filaLog=self.filaLog||{};
				for (var chave in self.filaLog) {
					if (self.filaLog.hasOwnProperty(chave)) {
						self.log(chave+" -- "+self.filaLog[chave].texto,"SEMCONEXAO",chave);
						if(!todos){
							break;
						}
					}
				}
				self.processandoFila = false;
			},todos?0:15000);
		}
	};

	ScreenService.showCustomDialogTemp = ScreenService.showCustomDialog;
	ScreenService.showCustomDialog = function(){
		//Caso o loader esteja com 4 pontos indica que ele será finalizado quando uma mensagem for exibida.
		if(window.ApplicationContext.templateManager.loadingMessage=="Aguarde...."){
			ScreenService.changeLoadingMessage("Aguarde...");
			ScreenService.restoreDefaultLoadingMessage();
			ScreenService.hideLoader();
		}
		self.log((arguments[0]||''),"LogFrontEnd");
		//return  ScreenService.showCustomDialogTemp(...args);
		return ScreenService.showCustomDialogTemp.apply(ScreenService, arguments);
	};

	ScreenService.notificationMessageTemp = ScreenService.notificationMessage;
	ScreenService.notificationMessage = function(){
		self.log((arguments[0]||''),"LogFrontEnd");
		//return  ScreenService.notificationMessageTemp(...args);
		return ScreenService.notificationMessageTemp.apply(ScreenService, arguments);
	};

	this.getInstanciaTEF = function(){
		var instanciaTEF = null;
		if(!!window.ZhGetNetAutomation) {
			instanciaTEF = window.ZhGetNetAutomation; // Getnet
		} else if(!!window.ZhADX8000Automation) {
			instanciaTEF = window.ZhADX8000Automation;
		} else if(!!window.ZhCapptaAutomation) { //Cappta
			instanciaTEF = window.ZhCapptaAutomation;
		} else if(!!window.ZhCieloAutomation) { // Cielo
			instanciaTEF = window.ZhCieloAutomation;
		} else if(!!window.zhSafraPayAutomation) { //SafraPay
			instanciaTEF = window.zhSafraPayAutomation;
		} else if(!!window.ZhStoneAutomation) { //Stone
			instanciaTEF = window.ZhStoneAutomation;
		} else if (window.ZhRedeAutomation){ // Rede
			instanciaTEF = window.ZhRedeAutomation;
		} else if (window.ZhGPOS720Automation){ // 
			instanciaTEF = window.ZhGPOS720Automation;
		} else if(!!window.cordova){
			if(!!window.cordova.plugins.GertecRede) { // Rede
				instanciaTEF = window.cordova.plugins.GertecRede;
			} else if(!!window.cordova.plugins.IntegrationService) {
				instanciaTEF = window.cordova.plugins.IntegrationService;
			} else if(!!window.cordova.plugins.GertecSitef) { //Sitef
				instanciaTEF = window.cordova.plugins.GertecSitef;
			}
		}
		return instanciaTEF;
	};
	
	this.validaModeloIMP = function(IDMODEIMPRES){
		//validar se existe a instancia da lib de impressão android
		if(
			(IDMODEIMPRES == '25' && existe(window,"cordova.plugins.GertecPrinter")) ||
			(IDMODEIMPRES == '25' && existe(window,"ZhGertecPrinter")) ||
			(IDMODEIMPRES == '26' && !!window.RedePoyntPrinterJSInterface) ||
			(IDMODEIMPRES == '27' && !!window.ZhCieloAutomation) ||
			(IDMODEIMPRES == '27' && !!window.ZhCieloPrinter) ||
			(IDMODEIMPRES == '28') ||
			(IDMODEIMPRES == '38' && existe(window,"ZhNewlandPrinter")) ||
			(IDMODEIMPRES == '38' && existe(window,"cordova.plugins.IntegrationService")) ||
			(IDMODEIMPRES == '39' && existe(window,"cordova.plugins.IntegrationService")) ||
			(IDMODEIMPRES == '40' && !!window.ZhStoneAutomation) ||
			(IDMODEIMPRES == '40' && !!window.ZhStonePrinter) ||
			(IDMODEIMPRES == '47' && !!window.ZhMiniPDVPrinter) ||
			(IDMODEIMPRES == '48' && !!window.ADX8000Printer) ||
			(IDMODEIMPRES == '49' && !!window.ZhSafraPayPrinter) ||
			(IDMODEIMPRES == '50' && !!window.ZhPositivoPrinter) ||
			(IDMODEIMPRES == '51' && !!window.GPOS720Printer)
		){
			return true;
			}
		return null;
	};
}


//Modos Waiter
var modosWaiter = {
	mesa: { codigo: "M", nome: "Mesa" },
	comanda: { codigo: "C", nome: "Comanda" },
	order: { codigo: "O", nome: "Order" },
	balcao: { codigo: "B", nome: "Balcão" }
};

var modosCaixa = {
	POS: { nome: "Venda balcão", modos: ["B"] },
	CMD: { nome: "Comanda + venda balcão", modos: ["C", "B"] },
	RES: { nome: "Restaurante + venda balcão", modos: ["M", "B"] },
	FOS: { nome: "Venda balcão + comanda + restaurante", modos: ["M", "B", "C"] },
	PKC: { nome: "Pocket comanda", modos: ["C"] },
	PKR: { nome: "Pocket restaurante", modos: ["M"] },
	TAA: { nome: "Terminal de auto atendimento", modos: [] },
	FKB: { nome: "Microterminal", modos: [] },
	EVB: { nome: "Delivery", modos: ["D"] },
	CTL: { nome: "Controle de Produção", modos: [] },
	CSE: { nome: "Controde de Saída e Entrada de Pedidos", modos: [] }
};

Configuration(function(ContextRegister) {
	ContextRegister.register("WindowService", WindowService);
});
